from ngsolve import *
#import netgen.gui
from netgen.csg import *
from netgen.geom2d import *
from cmath import polar
import ngsolve.special_functions
#
hmax=0.1
geo = CSGeometry()
inner_cyl1= Cylinder(Pnt(-2,0,0), Pnt(0,0,0), 1 ).bc("dirichlet")
inner_cyl2= Cylinder(Pnt(-3,0,0), Pnt(-2,0,0), 1 ).bc("dirichlet")
inner_right = Plane(Pnt(0,0,0),Vec(1,0,0)).maxh(hmax).bc("neumann")
inner_left = Plane(Pnt(-3,0,0),Vec(-1,0,0)).maxh(hmax)
s_plane1 = Plane(Pnt(-2,0,0),Vec(-1,0,0)).maxh(hmax).bc("observationplane")
s_plane2 = Plane(Pnt(-2,0,0),Vec(1,0,0)).maxh(hmax)
inner1 = inner_cyl1*inner_right*s_plane1
inner2 = inner_cyl2*s_plane2*inner_left
geo.Add(inner1.mat("inner1").col([1,0,0]))
geo.Add(inner2.mat("inner2").col([0,1,0]))
ngmesh = geo.GenerateMesh(maxh=hmax)
mesh = Mesh(ngmesh)
mesh.Curve(5)

P1=0
P2=1
print(Integrate(cos(P1*ngsolve.atan(y/z))*cos(P2*ngsolve.atan(y/z)),mesh,BND,definedon=mesh.Boundaries("observationplane"))) # cos functions are not orthogonal!!!
